'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _Subject = require('./Subject');

var _implementsReflectionImpl = require('../implements/ReflectionImpl');

/**
 * @typedef {Object} ActionData
 * @property {string} key
 * @property {*} value
 */

/**
 * The role of this class is the Flux `Action`.
 * Implements the behavior methods subclasses that inherit from it.
 * `publish` method is executed, and data flows from the `Observable` to `Store`.
 *
 * @class Action
 */

var Action = (function () {

  /**
   * @constructor
   */

  function Action() {
    _classCallCheck(this, Action);

    this.eventStream$ = _Subject['default'].stream();

    this.initialize();
  }

  _createClass(Action, [{
    key: 'initialize',

    /**
     *
     */
    value: function initialize() {}
  }, {
    key: 'publish',

    /**
     * @param {string} eventName
     * @param {*} payload
     */
    value: function publish(eventName, payload) {
      this.eventStream$.push({
        event: eventName,
        payload: payload
      });
    }
  }, {
    key: 'do',

    /**
     * alias of `publish()`
     * @param {string} eventName
     * @param {*} payload
     */
    value: function _do(eventName, payload) {
      return this.publish(eventName, payload);
    }
  }, {
    key: 'getClassName',

    /**
     * @returns {string}
     */
    value: function getClassName() {
      return _implementsReflectionImpl['default'].getClassName.apply(this);
    }
  }]);

  return Action;
})();

exports['default'] = Action;

// implements you want

/**
 * @type {Kefir.Stream<ActionData>}
 * @private
 */