'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

/**
 * @class SubscriberImpl
 */

var SubscriberImpl = (function () {
  function SubscriberImpl() {
    _classCallCheck(this, SubscriberImpl);

    this._subscriptions = [];
  }

  _createClass(SubscriberImpl, null, [{
    key: 'subscribe',

    /**
     * Subscribe to observable, that holds the subscription.
     * Become a memory leak if you subscribe using this method,
     * the end of instance lifecycle manually subscription must discard.
     *
     * @param {Observable} observable$
     * @param {function} observer
     */
    value: function subscribe(observable$, observer) {

      if (observable$ == null) {
        return;
      }

      var subscription = undefined;
      if (observable$.subscribe) {
        // Rx
        subscription = observable$.subscribe(observer);
      } else {
        // Bacon, Kefir
        observable$.onValue(observer);
        subscription = [observable$, observer];
      }

      this._subscriptions = this._subscriptions || [];
      this._subscriptions.push(subscription);
    }
  }, {
    key: 'unsubscribeAll',

    /**
     * To discard all subscriptions of the observable.
     */
    value: function unsubscribeAll() {
      this._subscriptions = this._subscriptions || [];

      this._subscriptions.forEach(function (subscription) {
        if (subscription.dispose) {
          // Rx
          subscription.dispose();
        } else {
          // Bacon, Kefir
          subscription[0].offValue(subscription[1]);
        }
      });
      this._subscriptions = [];
    }
  }]);

  return SubscriberImpl;
})();

exports['default'] = SubscriberImpl;

/**
 * @type {Array<Subscription>}
 */