'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _objectAssign = require('object-assign');

var assign = _objectAssign;

var _implementsReflectionImpl = require('../implements/ReflectionImpl');

var _utilsDecoratable = require('../utils/decoratable');

/**
 * @param {Component} Component
 * @param {React} React
 * @param {Array<Action>} ActionClasses
 * @returns {ActionsProvider}
 */
function provideActions(Component, React, ActionClasses) {

  /**
   * @class ActionsProvider
   */

  var ActionsProvider = (function (_React$Component) {
    function ActionsProvider() {
      _classCallCheck(this, ActionsProvider);

      if (_React$Component != null) {
        _React$Component.apply(this, arguments);
      }
    }

    _inherits(ActionsProvider, _React$Component);

    _createClass(ActionsProvider, [{
      key: 'getDisplayName',

      /**
       * for react dev-tools
       * @returns {string}
       */
      value: function getDisplayName() {
        return _implementsReflectionImpl['default'].getClassName.apply(this);
      }
    }, {
      key: 'render',

      /**
       *
       * @returns {*}
       */
      value: function render() {
        var _this = this;

        if (!this.context.getAction) {
          throw new Error('The context does not have `getAction`.' + 'Make sure the ancestral component provides the domain context, use `@provideContext`.');
        }

        var actions = {};
        ActionClasses.reduce(function (acc, ActionClass) {
          acc[ActionClass.name] = _this.context.getAction(ActionClass);
        }, actions);
        return React.createElement(Component, assign(actions, this.props));
      }
    }], [{
      key: '_originalComponent',

      /**
       * @type {Component}
       * @private
       */
      value: Component,
      enumerable: true
    }, {
      key: 'contextTypes',

      /**
       * @type {Object<string, function>}
       */
      value: {
        getAction: React.PropTypes.func.isRequired
      },
      enumerable: true
    }]);

    return ActionsProvider;
  })(React.Component);

  return ActionsProvider;
}

exports['default'] = (0, _utilsDecoratable['default'])(provideActions);