'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _classesDomain = require('../classes/Domain');

var _implementsReflectionImpl = require('../implements/ReflectionImpl');

var _utilsDecoratable = require('../utils/decoratable');

/**
 * @param {Component} Component
 * @param {React} React
 * @returns {ContextProvider}
 */
function provideContext(Component, React) {

  /**
   * @class ContextProvider
   */

  var ContextProvider = (function (_React$Component) {
    function ContextProvider() {
      _classCallCheck(this, ContextProvider);

      if (_React$Component != null) {
        _React$Component.apply(this, arguments);
      }

      this.childContexts = null;
    }

    _inherits(ContextProvider, _React$Component);

    _createClass(ContextProvider, [{
      key: 'componentWillMount',

      /**
       *
       */
      value: function componentWillMount() {
        if (!this.props.domain) {
          throw new Error('@provideContext higher-ordered component must have `props.domain`');
        }
        this.childContexts = {
          getAction: this.props.domain.getAction.bind(this.props.domain),
          getObservables: this.props.domain.getObservables.bind(this.props.domain)
        };
      }
    }, {
      key: 'getDisplayName',

      /**
       * for react dev-tools
       * @returns {string}
       */
      value: function getDisplayName() {
        return _implementsReflectionImpl['default'].getClassName.apply(this);
      }
    }, {
      key: 'getChildContext',

      /**
       * @returns {Object<string, function>}
       */
      value: function getChildContext() {
        return this.childContexts;
      }
    }, {
      key: 'render',

      /**
       * @returns {ReactElement}
       */
      value: function render() {
        return React.createElement(Component, this.props);
      }
    }], [{
      key: '_originalComponent',

      /**
       * @type {Component}
       * @private
       */
      value: Component,
      enumerable: true
    }, {
      key: 'propTypes',

      /**
       * @type {Object<string, function>}
       */
      value: {
        domain: React.PropTypes.instanceOf(_classesDomain['default']).isRequired
      },
      enumerable: true
    }, {
      key: 'childContextTypes',

      /**
       * @type {Object<string, function>}
       */
      value: {
        getAction: React.PropTypes.func.isRequired,
        getObservables: React.PropTypes.func.isRequired
      },
      enumerable: true
    }]);

    return ContextProvider;
  })(React.Component);

  return ContextProvider;
}

exports['default'] = (0, _utilsDecoratable['default'])(provideContext);

/**
 * @type {Object<string, function>}
 */